//+------------------------------------------------------------------+
//|                                 Accumulation-Distribution_v2.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

// Aug 09 5 digit broker routines added by macman
//

#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 8

string vline1 = "vLine1";
string vline2 = "vLine2";
string vline3 = "vLine3";
extern int numOfbars = 4;
extern int numOfbars2 = 6;
extern bool manual = false;
extern bool automanual = false;
extern bool digits_5 = True;
extern int barstart = 1;
extern double Time_Out=300;
extern bool Alert_on =False;
extern bool Pop_Up_Box=True;
extern bool showStats = true;
extern bool showPips = false;
extern int fontsize = 8; 
int bars[];
int vbars[];
int newbars[];
int vnewbars[];
int barsDoji[];
int vbarsDoji;
double volSum[];
double vvolSum[];
double range[];
double vrange[];
int bars1[];
int vbars1[];
double volSum1[];
double vvolSum1[];
double range1[];
double vrange1[];
double val[];
double val1[];
string highLine="highLine";
string lowLine="lowLine";
double totalup[];
double totaldown[];
double totalmid[];
double upperbar, lowerbar;
double totalup1[];
double totaldown1[];
double totalmid1[];
double upperbar1, lowerbar1;
double dojiup[];
double dojidown[];
double dojimid[];
double vtotalup[];
double vtotaldown[];
double vtotalmid[];
double vupperbar, vlowerbar;
double vtotalup1[];
double vtotaldown1[];
double vtotalmid1[];
double vdojiup[];
double vdojidown[];
double vdojimid[];
double timelock = -1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

IndicatorShortName("Accumulation-Distribution");

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,val);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,val1);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(manual == false){
   ObjectDelete(vline1);}
   if(automanual == false){
   ObjectDelete(vline2);}
   //ObjectDelete(vline3);
   ObjectDelete("Buyers");
   ObjectDelete("Sellers");
   ObjectDelete("Doji");
   ObjectDelete("Doji1");
   ObjectDelete("totalvol");
   ObjectDelete("pips");
   ObjectDelete(highLine);
   ObjectDelete(lowLine);
   ObjectDelete("BuyersA");
   ObjectDelete("SellersD");
   ObjectDelete("vBuyersA");
   ObjectDelete("vSellersD");
   ObjectDelete("UpCl");
   ObjectDelete("UpCl1");
   ObjectDelete("UpCl2");
   ObjectDelete("DownCl");
   ObjectDelete("DownCl1");
   ObjectDelete("DownCl2");
   ObjectDelete("MidCl");
   ObjectDelete("MidCl1");
   ObjectDelete("MidCl2");
   ObjectDelete("vUpCl");
   ObjectDelete("vUpCl1");
   ObjectDelete("vUpCl2");
   ObjectDelete("vDownCl");
   ObjectDelete("vDownCl1");
   ObjectDelete("vDownCl2");
   ObjectDelete("vMidCl");
   ObjectDelete("vMidCl1");
   ObjectDelete("vMidCl2");
   ObjectDelete("name");
   ObjectDelete("SD");
   ObjectDelete("vBA");
   ObjectDelete("vSD");
   ObjectDelete("long");
   ObjectDelete("short");
   ObjectDelete("wait");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   ObjectDelete("wait");
   ObjectDelete("long");
   ObjectDelete("short");
   ObjectDelete("Buyers");
   ObjectDelete("Sellers");
   ObjectDelete("Doji");
   ObjectDelete("Doji1");
   ObjectDelete("totalvol");
   ObjectDelete("pips");
   ObjectDelete(highLine);
   ObjectDelete(lowLine);
   ObjectDelete("BuyersA");
   ObjectDelete("SellersD");
   ObjectDelete("vBuyersA");
   ObjectDelete("vSellersD");
   ObjectDelete("UpCl");
   ObjectDelete("UpCl1");
   ObjectDelete("UpCl2");
   ObjectDelete("DownCl");
   ObjectDelete("DownCl1");
   ObjectDelete("DownCl2");
   ObjectDelete("MidCl");
   ObjectDelete("MidCl1");
   ObjectDelete("MidCl2");
   ObjectDelete("vUpCl");
   ObjectDelete("vUpCl1");
   ObjectDelete("vUpCl2");
   ObjectDelete("vDownCl");
   ObjectDelete("vDownCl1");
   ObjectDelete("vDownCl2");
   ObjectDelete("vMidCl");
   ObjectDelete("vMidCl1");
   ObjectDelete("vMidCl2");
   ObjectDelete("name");
   ObjectDelete("SD");
   ObjectDelete("vBA");
   ObjectDelete("vSD");
   if(manual == false){
   ObjectDelete(vline1);}
   if(automanual == false){
   ObjectDelete(vline2);}
   //ObjectDelete(vline3);
   
  
  
   int counted_bars=IndicatorCounted();
   
   if (ObjectFind(vline1)==-1)
     {
      ObjectCreate(vline1,OBJ_VLINE,0,Time[barstart],0); 
      ObjectSet(vline1,OBJPROP_COLOR,Purple);
      ObjectSet(vline1,OBJPROP_STYLE,STYLE_DASHDOTDOT);
      ObjectSet(vline1,OBJPROP_BACK,True);
      ObjectSetText(vline1,"vline1",8,"Courier",LightSteelBlue);
     }
   if (ObjectFind(vline2)==-1)
     {
      ObjectCreate(vline2,OBJ_VLINE,0,Time[numOfbars + barstart -1],0);
      ObjectSet(vline2,OBJPROP_COLOR,Purple);
      ObjectSet(vline2,OBJPROP_STYLE,STYLE_DASHDOTDOT);
      ObjectSet(vline2,OBJPROP_BACK,True);
      ObjectSetText(vline2,"vline2",8,"Courier",LightSteelBlue);
     }
    if(showPips == True){ 
     if (ObjectFind(vline3)==-1)
     {
      ObjectCreate(vline3,OBJ_VLINE,0,Time[barstart + numOfbars + numOfbars2],0);
      ObjectSet(vline3,OBJPROP_COLOR,Purple);
      ObjectSet(vline3,OBJPROP_STYLE,STYLE_DASHDOTDOT);
      ObjectSet(vline3,OBJPROP_BACK,True);
      ObjectSetText(vline3,"vline3",8,"Courier",LightSteelBlue);
     }
datetime dt3 = ObjectGet("vline3", 0);   
int vline3 = iBarShift( NULL, 0, dt3, false) ;
}    
          
datetime dt1 = ObjectGet("vline1", 0); //called time of object
datetime dt2 = ObjectGet("vline2", 0);
int vline1 = iBarShift( NULL, 0, dt1, false) ;//assign date and time to line
int vline2 = iBarShift( NULL, 0, dt2, false) ; //Alert(vline1);

//Calculation for Doji Bars

for (int i = vline1; i <= vline2; i++){
      if (Open[i] == Close[i]){
         
         int barsDoji = barsDoji + 1;
      }      
   }

//Calculations for Buyers

   for (i = vline1; i <= vline2; i++){
      if ((Open[i] > Close[i]) - 1){
         
         int bars = bars +1;
         double range = (High[i] - Low[i]) / Point;
         double totalRange =  totalRange + range;//count
         double volSum = volSum + Volume[i]; 
      }    
   }

//Calculations for Sellers

   for (i = vline1; i <= vline2; i++){
      if ((Open[i] < Close[i]) - 1){
         
         int bars1 = bars1 +1;
         double range1 = (High[i] - Low[i]) / Point;
         double totalRange1 =  totalRange1 + range1;
         double volSum1 = volSum1 + Volume[i]; 
      }       
   }


int newbars = bars - barsDoji;
int newbars1 = bars1 - barsDoji;
double volumeRatio = volSum1 / volSum;
double volumeRatio1 = volSum / volSum1;
//double totalvol = (volSum + volSum1)/(bars + bars1);


//Calculations for Buyers #2
if(showPips == true){
   for (i = vline1; i <= vline3; i++){
      if ((Open[i] > Close[i]) - 1){
         
         int vbars = vbars +1;
         double vrange = (High[i] - Low[i]) / Point;
         double vtotalRange =  vtotalRange + vrange;//count
         double vvolSum = vvolSum + Volume[i]; 
      }     
   }
  } 


//Calculations for Sellers #2
if(showPips == true){
   for (i = vline1; i <= vline3; i++){
      if ((Open[i] < Close[i]) - 1){
         
         int vbars1 = vbars1 +1;
         double vrange1 = (High[i] - Low[i]) / Point;
         double vtotalRange1 =  vtotalRange1 + vrange1;
         double vvolSum1 = vvolSum1 + Volume[i]; 
      }       
   } 
//double volavg1 = volSum1 / bars1; 
//double avgRange1 = totalRange1 / bars1; //-----------#2

int vnewbars = vbars - vbarsDoji;
int vnewbars1 = vbars1 - vbarsDoji;
double vvolumeRatio = vvolSum1 / vvolSum;
double vvolumeRatio1 = vvolSum / vvolSum1;
double vtotalvol = (vvolSum + vvolSum1)/(vbars + vbars1);
}  

   if(digits_5 == true){
      totalRange = totalRange/10; 
      totalRange1 = totalRange1/10;
      volSum = volSum/10;
      volSum1 = volSum1/10;
      
      }   

 
 if(showStats == true){
   ObjectCreate("Buyers", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Buyers","Totals: " + "Bars " + DoubleToStr(newbars,0) + "    " + "Range: " + DoubleToStr(totalRange,0)
   + "    " + "Vol: " + DoubleToStr(volSum,0), fontsize, "Comic Sans MS Bold" ,Lime);
   ObjectSet("Buyers", OBJPROP_CORNER, 1);
   ObjectSet("Buyers", OBJPROP_XDISTANCE, 5);
   ObjectSet("Buyers", OBJPROP_YDISTANCE, 10);
   
   ObjectCreate("Sellers", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Sellers","Bars " + DoubleToStr(newbars1,0) + "    " + "Range: " + DoubleToStr(totalRange1,0)
   + "    " + "Vol: " + DoubleToStr(volSum1,0), fontsize, "Comic Sans MS Bold" ,Crimson);
   ObjectSet("Sellers", OBJPROP_CORNER, 1);
   ObjectSet("Sellers", OBJPROP_XDISTANCE, 5);
   ObjectSet("Sellers", OBJPROP_YDISTANCE, 25);
   
   
   if(volSum <= volSum1){
   ObjectCreate("Doji", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Doji","Doji: " + DoubleToStr(barsDoji,0) + "    " +"B/S Ratio:  " + " 1.0 / " + DoubleToStr(volumeRatio,2), fontsize, "Comic Sans MS Bold" ,White);
   ObjectSet("Doji", OBJPROP_CORNER, 1);
   ObjectSet("Doji", OBJPROP_XDISTANCE, 5);
   ObjectSet("Doji", OBJPROP_YDISTANCE, 40);}
   else
   if(volSum > volSum1){
   ObjectCreate("Doji1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Doji1","Doji: " + DoubleToStr(barsDoji,0) + "    " +"B/S Ratio:  " + DoubleToStr(volumeRatio1,3) + " / 1.0", fontsize, "Comic Sans MS Bold" ,White);
   ObjectSet("Doji1", OBJPROP_CORNER, 1);
   ObjectSet("Doji1", OBJPROP_XDISTANCE, 5);
   ObjectSet("Doji1", OBJPROP_YDISTANCE, 40);}
   }
   
   
   
   for (i = vline1; i <= vline2; i++){
      int barstotal = newbars + newbars1 + barsDoji; 
      double val=High[iHighest(NULL,0,MODE_HIGH,barstotal,vline1)];
      double val1=Low[iLowest(NULL,0,MODE_LOW,barstotal,vline1)];
      } //Alert(barstotal);
      
      if (ObjectFind(highLine)==-1)
     {
      ObjectCreate(highLine,OBJ_HLINE,0,0,val,Digits); 
      ObjectSet(highLine,OBJPROP_COLOR,Purple);
      ObjectSet(highLine,OBJPROP_STYLE,STYLE_DASH);
      ObjectSetText(highLine,"val",8,"Courier",LightSteelBlue);
     }
   if (ObjectFind(lowLine)==-1)
     {
      ObjectCreate(lowLine,OBJ_HLINE,0,0,val1,Digits);
      ObjectSet(lowLine,OBJPROP_COLOR,Purple);
      ObjectSet(lowLine,OBJPROP_STYLE,STYLE_DASH);
      ObjectSetText(lowLine,"val1",8,"Courier",LightSteelBlue);
     }
     
     

   if(showStats == true){
   double pips = (val - val1) / Point;
  
   
   if(digits_5 == true){
      pips = pips/10;
    }
 
   ObjectCreate("totalvol", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("totalvol",/*"VolAvg: " + DoubleToStr(totalvol,0) + */"   H/L: " + DoubleToStr(pips,0) + " pips" + "   Total Bars: " + DoubleToStr(barstotal,0), fontsize, "Comic Sans MS Bold" ,Orange);
   ObjectSet("totalvol", OBJPROP_CORNER, 1);
   ObjectSet("totalvol", OBJPROP_XDISTANCE, 5);
   ObjectSet("totalvol", OBJPROP_YDISTANCE, 60);
   }

      
//--------------Bar Close--------------------------------------------+
   
   
   
   
   
   for ( i = vline1; i <= vline2; i++){
   double Range = (High[i] - Low[i]);
   upperbar= High[i] - (Range * 0.30);
   lowerbar = Low[i] + (Range * 0.30);
   
   if (Close[i] == Open[i]){
      
         if( Close[i] >= upperbar){double dojiup = dojiup + 1;} //Alert(dojiup);
            
         if( (Close[i] <= lowerbar)){double dojidown = dojidown + 1;} 
            
         if( (Close[i] < upperbar) && (Close[i] > lowerbar)){double dojimid = dojimid + 1;}
         }
       }
   
   for (i = vline1; i <= vline2; i++){ 
   Range = (High[i] - Low[i]);
   upperbar= High[i] - (Range * 0.30);
   lowerbar = Low[i] + (Range * 0.30);
   
   if ((Close[i] > Open[i]) && (Close[i] != Open[i])){        
         
         if( Close[i] >= upperbar){double totalup = totalup + 1;} 
             
         if( (Close[i] <= lowerbar)){double totaldown = totaldown + 1; double totaldownvol = totaldownvol + Volume[i];} 
            
         if( (Close[i] < upperbar) && (Close[i] > lowerbar)){double totalmid = totalmid + 1;}           
      }
    }  
      
      for ( i = vline1; i <= vline2; i++){
      Range = (High[i] - Low[i]);
      upperbar= High[i] - (Range * 0.30);
      lowerbar = Low[i] + (Range * 0.30);
      
      if ((Close[i] < Open[i]) && (Close[i] != Open[i])){
      
         if( Close[i] >= upperbar){double totalup1 = totalup1 + 1; double totalupvol = totalupvol + Volume[i];} 
            
         if( (Close[i] <= lowerbar)){double totaldown1 = totaldown1 + 1;} 
            
         if( (Close[i] < upperbar) && (Close[i] > lowerbar)){double totalmid1 = totalmid1 + 1;}
      }
   } 
   
   //--------------Bar Close Vertical Line 3--------------------------------------------+
  if(showStats == true){ 
   for ( i = vline1; i <= vline3; i++){
   double vRange = (High[i] - Low[i]);
   vupperbar= High[i] - (vRange * 0.30);
   vlowerbar = Low[i] + (vRange * 0.30);
   
   if (Close[i] == Open[i]){
      
         if( Close[i] >= vupperbar){double vdojiup = vdojiup + 1;} //Alert(dojiup);
            
         if( (Close[i] <= vlowerbar)){double vdojidown = vdojidown + 1;} 
            
         if( (Close[i] < vupperbar) && (Close[i] > vlowerbar)){double vdojimid = vdojimid + 1;}
         }
       }
   
   for (i = vline1; i <= vline3; i++){ 
   vRange = (High[i] - Low[i]);
   vupperbar= High[i] - (vRange * 0.30);
   vlowerbar = Low[i] + (vRange * 0.30);
   
   if ((Close[i] > Open[i]) && (Close[i] != Open[i])){        
         
         if( Close[i] >= vupperbar){double vtotalup = vtotalup + 1;} 
             
         if( (Close[i] <= vlowerbar)){double vtotaldown = vtotaldown + 1; double vtotaldownvol = vtotaldownvol + Volume[i];} 
            
         if( (Close[i] < vupperbar) && (Close[i] > vlowerbar)){double vtotalmid = vtotalmid + 1;}           
      }
    }  
      
      for ( i = vline1; i <= vline3; i++){
      vRange = (High[i] - Low[i]);
      vupperbar= High[i] - (vRange * 0.30);
      vlowerbar = Low[i] + (vRange * 0.30);
      
      if ((Close[i] < Open[i]) && (Close[i] != Open[i])){
      
         if( Close[i] >= vupperbar){double vtotalup1 = vtotalup1 + 1; double vtotalupvol = vtotalupvol + Volume[i];} 
            
         if( (Close[i] <= vlowerbar)){double vtotaldown1 = vtotaldown1 + 1;} 
            
         if( (Close[i] < vupperbar) && (Close[i] > vlowerbar)){double vtotalmid1 = vtotalmid1 + 1;}
      }
   }
 }   
   
// Bar Close Buyers---------------------------------------+
      if(showStats == true){   
      ObjectCreate("UpCl", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("UpCl","UpClose: " + DoubleToStr(totalup,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("UpCl", OBJPROP_CORNER, 1);
      ObjectSet("UpCl", OBJPROP_XDISTANCE, 50);
      ObjectSet("UpCl", OBJPROP_YDISTANCE, 80);
         
      ObjectCreate("DownCl", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("DownCl","DownClose: " + DoubleToStr(totaldown,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("DownCl", OBJPROP_CORNER, 1);
      ObjectSet("DownCl", OBJPROP_XDISTANCE, 50);
      ObjectSet("DownCl", OBJPROP_YDISTANCE, 95);
      
      ObjectCreate("MidCl", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("MidCl","MidClose: " + DoubleToStr(totalmid,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("MidCl", OBJPROP_CORNER, 1);
      ObjectSet("MidCl", OBJPROP_XDISTANCE, 50);
      ObjectSet("MidCl", OBJPROP_YDISTANCE, 110);

// Bar Close Sellers-------------------------------------------+      
      
      ObjectCreate("UpCl1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("UpCl1"," " + DoubleToStr(totalup1,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("UpCl1", OBJPROP_CORNER, 1);
      ObjectSet("UpCl1", OBJPROP_XDISTANCE, 30);
      ObjectSet("UpCl1", OBJPROP_YDISTANCE, 80);
         
      ObjectCreate("DownCl1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("DownCl1"," " + DoubleToStr(totaldown1,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("DownCl1", OBJPROP_CORNER, 1);
      ObjectSet("DownCl1", OBJPROP_XDISTANCE, 30);
      ObjectSet("DownCl1", OBJPROP_YDISTANCE, 95);
      
      ObjectCreate("MidCl1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("MidCl1"," " + DoubleToStr(totalmid1,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("MidCl1", OBJPROP_CORNER, 1);
      ObjectSet("MidCl1", OBJPROP_XDISTANCE, 30);
      ObjectSet("MidCl1", OBJPROP_YDISTANCE, 110);
      
      // Doji Bars Close -------------------------------------------+      
      
      ObjectCreate("UpCl2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("UpCl2"," " + DoubleToStr(dojiup,0), fontsize, "Comic Sans MS Bold" ,White);
      ObjectSet("UpCl2", OBJPROP_CORNER, 1);
      ObjectSet("UpCl2", OBJPROP_XDISTANCE, 10);
      ObjectSet("UpCl2", OBJPROP_YDISTANCE, 80);
         
      ObjectCreate("DownCl2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("DownCl2"," " + DoubleToStr(dojidown,0), fontsize, "Comic Sans MS Bold" ,White);
      ObjectSet("DownCl2", OBJPROP_CORNER, 1);
      ObjectSet("DownCl2", OBJPROP_XDISTANCE, 10);
      ObjectSet("DownCl2", OBJPROP_YDISTANCE, 95);
      
      ObjectCreate("MidCl2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("MidCl2"," " + DoubleToStr(dojimid,0), fontsize, "Comic Sans MS Bold" ,White);
      ObjectSet("MidCl2", OBJPROP_CORNER, 1);
      ObjectSet("MidCl2", OBJPROP_XDISTANCE, 10);
      ObjectSet("MidCl2", OBJPROP_YDISTANCE, 110);
      }  
      
      // Bar Close Buyers #2---------------------------------------+   
      
      if(showPips == true){
      ObjectCreate("vUpCl", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vUpCl","UpClose: " + DoubleToStr(vtotalup,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("vUpCl", OBJPROP_CORNER, 3);
      ObjectSet("vUpCl", OBJPROP_XDISTANCE, 50);
      ObjectSet("vUpCl", OBJPROP_YDISTANCE, 5);
         
      ObjectCreate("vDownCl", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vDownCl","DownClose: " + DoubleToStr(vtotaldown,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("vDownCl", OBJPROP_CORNER, 3);
      ObjectSet("vDownCl", OBJPROP_XDISTANCE, 50);
      ObjectSet("vDownCl", OBJPROP_YDISTANCE, 20);
      
      ObjectCreate("vMidCl", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vMidCl","MidClose: " + DoubleToStr(vtotalmid,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("vMidCl", OBJPROP_CORNER, 3);
      ObjectSet("vMidCl", OBJPROP_XDISTANCE, 50);
      ObjectSet("vMidCl", OBJPROP_YDISTANCE, 35);

// Bar Close Sellers #2-------------------------------------------+      
      
      ObjectCreate("vUpCl1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vUpCl1"," " + DoubleToStr(vtotalup1,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("vUpCl1", OBJPROP_CORNER, 3);
      ObjectSet("vUpCl1", OBJPROP_XDISTANCE, 30);
      ObjectSet("vUpCl1", OBJPROP_YDISTANCE, 5);
         
      ObjectCreate("vDownCl1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vDownCl1"," " + DoubleToStr(vtotaldown1,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("vDownCl1", OBJPROP_CORNER, 3);
      ObjectSet("vDownCl1", OBJPROP_XDISTANCE, 30);
      ObjectSet("vDownCl1", OBJPROP_YDISTANCE, 20);
      
      ObjectCreate("vMidCl1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vMidCl1"," " + DoubleToStr(vtotalmid1,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("vMidCl1", OBJPROP_CORNER, 3);
      ObjectSet("vMidCl1", OBJPROP_XDISTANCE, 30);
      ObjectSet("vMidCl1", OBJPROP_YDISTANCE, 35);
      
      // Doji Bars Close #2 -------------------------------------------+      
      
      ObjectCreate("vUpCl2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vUpCl2"," " + DoubleToStr(vdojiup,0), fontsize, "Comic Sans MS Bold" ,White);
      ObjectSet("vUpCl2", OBJPROP_CORNER, 3);
      ObjectSet("vUpCl2", OBJPROP_XDISTANCE, 10);
      ObjectSet("vUpCl2", OBJPROP_YDISTANCE, 5);
         
      ObjectCreate("vDownCl2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vDownCl2"," " + DoubleToStr(vdojidown,0), fontsize, "Comic Sans MS Bold" ,White);
      ObjectSet("vDownCl2", OBJPROP_CORNER, 3);
      ObjectSet("vDownCl2", OBJPROP_XDISTANCE, 10);
      ObjectSet("vDownCl2", OBJPROP_YDISTANCE, 20);
      
      ObjectCreate("vMidCl2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vMidCl2"," " + DoubleToStr(vdojimid,0), fontsize, "Comic Sans MS Bold" ,White);
      ObjectSet("vMidCl2", OBJPROP_CORNER, 3);
      ObjectSet("vMidCl2", OBJPROP_XDISTANCE, 10);
      ObjectSet("vMidCl2", OBJPROP_YDISTANCE, 35);  
      }
      //-----------------Accumulation - Distribution Score------------------------------+
        
   double BuyersA = (totalRange * (volSum + totalupvol)) / 100;
   double SellersD = (totalRange1 * (volSum1 + totaldownvol) / 100); 
   
   if(BuyersA > SellersD){
      ObjectCreate("BuyersA", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("BuyersA","ACCUMULATION", fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("BuyersA", OBJPROP_CORNER, 1);
      ObjectSet("BuyersA", OBJPROP_XDISTANCE, 10);
      ObjectSet("BuyersA", OBJPROP_YDISTANCE, 130);}
  else 
    if(BuyersA < SellersD){
      ObjectCreate("SellersD", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SellersD","DISTRIBUTION", fontsize, "Comic Sans MS Bold" ,Red);
      ObjectSet("SellersD", OBJPROP_CORNER, 1);
      ObjectSet("SellersD", OBJPROP_XDISTANCE, 10);
      ObjectSet("SellersD", OBJPROP_YDISTANCE, 130);}   
      
      
      //-----------------Accumulation - Distribution Score #2------------------------------+
   if(showPips == true){     
   double vBuyersA = (vtotalRange * (vvolSum + vtotalupvol)) / 100;
   double vSellersD = (vtotalRange1 * (vvolSum1 + vtotaldownvol) / 100);
   
      ObjectCreate("name", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("name","vLine3", 10, "Comic Sans MS Bold" ,White);
      ObjectSet("name", OBJPROP_CORNER, 3);
      ObjectSet("name", OBJPROP_XDISTANCE, 25);
      ObjectSet("name", OBJPROP_YDISTANCE, 65);
    
   
   if(vBuyersA > vSellersD){
      ObjectCreate("vBuyersA", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vBuyersA","ACCUMULATION", fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("vBuyersA", OBJPROP_CORNER, 3);
      ObjectSet("vBuyersA", OBJPROP_XDISTANCE, 5);
      ObjectSet("vBuyersA", OBJPROP_YDISTANCE, 50);}
  else 
    if(vBuyersA < vSellersD){
      ObjectCreate("vSellersD", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vSellersD","DISTRIBUTION", fontsize, "Comic Sans MS Bold" ,Red);
      ObjectSet("vSellersD", OBJPROP_CORNER, 3);
      ObjectSet("vSellersD", OBJPROP_XDISTANCE, 5);
      ObjectSet("vSellersD", OBJPROP_YDISTANCE, 50);}
      }   
      
      //--------Test------------------------+
      /*if(showPips == true){
      ObjectCreate("BA", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("BA","Buy score = " + DoubleToStr(BuyersA,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("BA", OBJPROP_CORNER, 1);
      ObjectSet("BA", OBJPROP_XDISTANCE, 10);
      ObjectSet("BA", OBJPROP_YDISTANCE, 60);
      
      ObjectCreate("SD", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("SD","Sell score = " + DoubleToStr(SellersD,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("SD", OBJPROP_CORNER, 1);
      ObjectSet("SD", OBJPROP_XDISTANCE, 10);
      ObjectSet("SD", OBJPROP_YDISTANCE, 80);
      }*/
      
      //--------Test #2------------------------+
      
      /*if(showPips == true){
      ObjectCreate("vBA", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vBA","Buy score = " + DoubleToStr(vBuyersA,0), fontsize, "Comic Sans MS Bold" ,Lime);
      ObjectSet("vBA", OBJPROP_CORNER, 3);
      ObjectSet("vBA", OBJPROP_XDISTANCE, 10);
      ObjectSet("vBA", OBJPROP_YDISTANCE, 80);
      
      ObjectCreate("vSD", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("vSD","Sell score = " + DoubleToStr(vSellersD,0), fontsize, "Comic Sans MS Bold" ,Crimson);
      ObjectSet("vSD", OBJPROP_CORNER, 3);
      ObjectSet("vSD", OBJPROP_XDISTANCE, 10);
      ObjectSet("vSD", OBJPROP_YDISTANCE, 65);*/
      
      
//---------------Long or Short Trade----------------------------------------------+

   /*if(BuyersA > SellersD && vBuyersA > vSellersD){
      ObjectCreate("long", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("long","Only Long Trades!", 10, "Comic Sans MS" ,Lime);
      ObjectSet("long", OBJPROP_CORNER, 3);
      ObjectSet("long", OBJPROP_XDISTANCE, 10);
      ObjectSet("long", OBJPROP_YDISTANCE, 140);}
  else 
    if(BuyersA < SellersD && vBuyersA < vSellersD){
      ObjectCreate("short", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("short","Only Short Trades!", 10, "Comic Sans MS" ,Red);
      ObjectSet("short", OBJPROP_CORNER, 3);
      ObjectSet("short", OBJPROP_XDISTANCE, 10);
      ObjectSet("short", OBJPROP_YDISTANCE, 140);}
      
      else 
      {
      ObjectCreate("Wait", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Wait","Wait For Setup!", 10, "Comic Sans MS" ,White);
      ObjectSet("Wait", OBJPROP_CORNER, 3);
      ObjectSet("Wait", OBJPROP_XDISTANCE, 10);
      ObjectSet("Wait", OBJPROP_YDISTANCE, 140);}
      }*/         
      
 //--------Alert---------------------------------------------------------------------+
        
   if (BuyersA > SellersD  &&  TimeLocal() > timelock  && Alert_on ==true) 

        {           
            timelock= TimeLocal();  //done just for a slight pause
           
         if (Pop_Up_Box == False)  //if both of these choices are false, we default to just playing the sounds.
            {
             PlaySound("analyze buy.wav");
            }
        else 
            {
             timelock = TimeLocal();
             
             if (Pop_Up_Box == true) 
                 {
                  Alert("Buyers In Control on " + Symbol() + "  " + Period() + " min");  //we will shoot an alert, but then go for a few seconds delay if full voice is on
                 } 
                  
            }
            timelock = TimeLocal()+Time_Out;   //how many seconds do we lock out the Alert
        }
        //-------------------------------------------------------------------------------------------
        
        if (BuyersA < SellersD  &&  TimeLocal() > timelock  && Alert_on ==true) 

        {           
            timelock= TimeLocal();  //done just for a slight pause
           
         if (Pop_Up_Box == False)  //if both of these choices are false, we default to just playing the sounds.
            {
             PlaySound("analyze sell.wav");
            }
        else 
            {
             timelock = TimeLocal();
             
             if (Pop_Up_Box == true) 
                 {
                  Alert("Sellers In Control on " + Symbol() + "  " + Period() + " min");  //we will shoot an alert, but then go for a few seconds delay if full voice is on
                 } 
                  
            }
            timelock = TimeLocal()+Time_Out;   //how many seconds do we lock out the Alert
        }        
//----
   return(0);
  }
//+------------------------------------------------------------------+